
package etunicorn.generated;

import java.math.BigDecimal;
import java.util.Date;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


/**
 * No description
 * (Generated with springmvc-raml-parser v.0.8.9)
 * 
 */
@RestController
@RequestMapping("/v1/personne")
public interface PersonneController {


    /**
     * Obtenir la liste des persones. Nécessite COMPTE_ADMIN
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.GET)
    public ResponseEntity<?> getPersonne();

    /**
     * Ajoute une nouvelle personne
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.POST)
    public ResponseEntity<?> updatePersonne(
        @RequestParam(required = false)
        String carte,
        @RequestParam(required = false)
        Date naissance,
        @RequestParam(required = false)
        String login,
        @RequestParam(required = false, defaultValue = "etudiant")
        String role);

    /**
     * Obtenir les infos sur une personne. Nécessite COMPTE_ADMIN
     * 
     */
    @RequestMapping(value = "/{idPersonne}", method = RequestMethod.GET)
    public ResponseEntity<?> getPersonneById(
        @PathVariable
        BigDecimal idPersonne);

    /**
     * Modifer les infos d'une personne. Nécessite COMPTE_ADMIN
     * 
     */
    @RequestMapping(value = "/{idPersonne}", method = RequestMethod.PUT)
    public ResponseEntity<?> updatePersonneById(
        @PathVariable
        BigDecimal idPersonne,
        @RequestParam(required = false)
        String carte,
        @RequestParam(required = false)
        Date naissance,
        @RequestParam(required = false)
        String login,
        @RequestParam(required = false)
        String role);

    /**
     * Obtenir les infos sur une personne. Nécessite COMPTE_ADMIN
     * 
     */
    @RequestMapping(value = "/{idPersonne}", method = RequestMethod.DELETE)
    public ResponseEntity<?> deletePersonneById(
        @PathVariable
        BigDecimal idPersonne);

}
